import { IConnectionStatusListener } from './IConnectionStatusListener';
import { IEventListener } from './IEventListener';
import { SyncConfig } from './SyncConfig';
export default class StompConnection {
    private sessionSubscription;
    private sessionToken;
    statusListener: IConnectionStatusListener;
    private eventListener;
    private config;
    private stompClient;
    private onReady;
    private fullyConnected;
    private pending;
    constructor(config: SyncConfig, statusListener: IConnectionStatusListener, eventListener: IEventListener, onReady: () => any);
    send(event: object): void;
    connect(): void;
    private wsConnect(csrfToken?);
    private onStompConnected(frame);
    private onStompDisconnected(msg?);
    private onSystemConnected();
    isFullyConnected(): boolean;
    private onSessionChannelConnected();
    private disconnect();
}
