import { IncomingEvents } from './Events';
import { IEventListener } from './IEventListener';
import { ISyncArea } from './ISyncArea';
import { SyncArea } from './SyncArea';
export default class SyncAreaRegistry implements IEventListener {
    private areas;
    constructor();
    add(area: SyncArea): void;
    get(name: string): ISyncArea;
    forEach(callback: (area: SyncArea) => any): void;
    onEvent(event: IncomingEvents): void;
    private onInit(event);
    private onPatchAreaResponse(event);
    private onPatchAreaEvent(event);
    private onSubscribeAreaResponse(event);
    private onUnsubscribeAreaResponse(event);
    private onPatchAreaError(event);
    private onSubscribeAreaError(event);
    private onSignalResponse(event);
    private onSignalError(event);
}
